```
#include "max6675.h"                // Biblioteca do termopar
#include <SPI.h>                    // Biblioteca de comunicação com o visor
#include "U8glib.h"                 // Biblioteca do visor



float temperatura = 0;  // Variavel para pegar temperatura atual

float temperaturacha = 0;   
float tempocha = 0;       // Variaveis para temperatura e tempo para cada tipo de cha

float tempo = 0;      // tempo final 
float tempoinicial = 0; // tempo inicial
float tempototal = 0;  // Delta t

int botao = 7; // Pinagem do botao 
int estadobotao = 0;  // Guardar o estado do botao (HIGH ou LOW)
int cha = 0;    // Tipo de cha

int thermoDO = 4;
int thermoCS = 5;
int thermoCLK = 6;    // Pinagem do termopar 

int iniciar = 0;   // Utilizado para rodar alguns comandos apenas uma vez
int rele = 8;  // pinagem do rele



U8GLIB_SSD1306_128X32 u8g(U8G_I2C_OPT_NONE);    // Biblioteca do oled pede este comando para definir o tipo de tela


MAX6675 thermocouple(thermoCLK, thermoCS, thermoDO);  // Biblioteca do termopar pede este comando


void setup() {
  if (iniciar == 0) { // if para fazer os comandos iniciais apenas uma vez
    // assign default color value
    if ( u8g.getMode() == U8G_MODE_R3G3B2 ) {
      u8g.setColorIndex(255);     // white
    }
    else if ( u8g.getMode() == U8G_MODE_GRAY2BIT ) {
      u8g.setColorIndex(3);         // max intensity
    }
    else if ( u8g.getMode() == U8G_MODE_BW ) {
      u8g.setColorIndex(1);         // pixel on
    }
    else if ( u8g.getMode() == U8G_MODE_HICOLOR ) {
      u8g.setHiColorByRGB(255, 255, 255);

    }

    pinMode(botao, INPUT_PULLUP);
    pinMode(13, OUTPUT);
    pinMode(8, OUTPUT);      // Definicao dos pinos (saida ou entrada)
    digitalWrite(rele, LOW);      // Desligar o rele para evitar acidentes 
    delay(500);
    iniciar = iniciar + 1;  // ao fazer iniciar = 1, o if nao rodara mais. Fazendo rodar apenas uma vez

  }

  u8g.firstPage();  
  do {
    u8g.setFont(u8g_font_unifont);
    u8g.drawStr( 5, 15, "Escolha seu cha");
  } while ( u8g.nextPage() );

  // toda vez que for printar uma coisa no oled, este codigo é necessario.
  delay(500);

  tempoinicial = 0;
  tempo = 0;
  tempototal = 0;
  tempoinicial = millis();// a funcao millis pega o horario do arduino uno.
  
  while (tempototal <= 5000) {
    
    estadobotao = digitalRead(7);
    
    if (estadobotao == LOW) { // LOW = botao apertado
      
      digitalWrite(13, HIGH);// toda vez que quiser testar o botão, ele ascende um ledzinho.
      
      cha = cha + 1;
    }
    tempo = millis(); //tempo atual
    
    tempototal = tempo - tempoinicial;  //delta t
    
    delay(150);  // tempo para o led ficar ligado
    
    digitalWrite(13, LOW);     // desligar o led

  }
  tea(); // funcao para definir tipo de cha
}

void loop() {
  
  u8g.firstPage();
  
  do {
    
    u8g.setFont(u8g_font_unifont);
    u8g.drawStr( 5, 15, "Cha ");
    u8g.setPrintPos(35, 15);
    u8g.print(cha);
    u8g.drawStr( 50, 15, "escolhido ");
    if (cha == 1) { //cha preto
      u8g.drawStr( 5, 30, "Cha preto ");
    }
    else if (cha == 2) { //cha branco
      u8g.drawStr( 5, 30, "Cha branco ");
    }
    else if (cha == 3) { //cha verde
      u8g.drawStr( 5, 30, "Cha verde ");
    }
    else if (cha == 4) { //cha amarelo
      u8g.drawStr( 5, 30, "Cha amarelo ");
    }

  } while ( u8g.nextPage() );

  // rebuild the picture after some delay
  delay(4000); // manter a mensagem por 4 segundos na tela

  u8g.firstPage();
  do {
    u8g.setFont(u8g_font_unifont);
    u8g.drawStr( 5, 15, "Coloque o aque-");
    u8g.drawStr( 5, 30, "cedor");
  } while ( u8g.nextPage() );
  // rebuild the picture after some delay
  delay(4000);    // manter  por 4 segundos na tela
  
  digitalWrite(rele, HIGH);   // Ligar o rabo  quente
  
  temperatura = thermocouple.readCelsius();   // Pegar temperatura atual
  
  while(temperatura < temperaturacha){  // enquanto nao atingir a temperatura ideal do cha:
      
  temperatura = thermocouple.readCelsius();

  u8g.firstPage();
  do {
    u8g.setFont(u8g_font_unifont);
    u8g.drawStr( 5, 15, "Temperatura: ");
    u8g.setPrintPos(5, 30);
    u8g.print(temperatura);
    u8g.drawCircle(47, 20, 2);
    u8g.drawStr( 45, 30, " C");

  } while ( u8g.nextPage() );    // Printar temperatura 
  delay(2000);
  }

  if (temperatura >= temperaturacha) {     // Se chegar a temperatura ideal, pegara o tempo inicial para o Delta T
    tempoinicial = millis();
    controletemperatura();    // Chama a funcao controletemperatura();
  }
  
}

void controletemperatura() {
   u8g.firstPage();
    do {
      u8g.setFont(u8g_font_unifont);
      u8g.drawStr( 5, 15, "Coloque o cha");
    } while ( u8g.nextPage() );
    delay(3000);      // Printa "Coloque o cha" por 3 segundos
    
  while (tempototal < tempocha) {   // Enquanto nao der o tempo ideal, a funcao rodará
  tempo = millis();    // tempofinal
  tempototal = tempo - tempoinicial;    // Delta T
    
    if(temperatura >= temperaturacha){
      digitalWrite(rele, LOW);  // Desliga o rele se a temperatura for alta demais

    }
    if(temperatura < temperaturacha -3){
      digitalWrite(rele, HIGH);  // Liga o rede se a temperatura for baixa demais
    }
  
  
  u8g.firstPage();
  do {
    u8g.setFont(u8g_font_unifont);
    u8g.drawStr( 5, 15, "Temperatura: ");
    u8g.setPrintPos(5, 30);
    temperatura = thermocouple.readCelsius();
    u8g.print(temperatura);
    u8g.drawCircle(47, 20, 2);
    u8g.drawStr( 45, 30, " C");

  } while ( u8g.nextPage() );
  delay(1000);        // Printa a temperatura atual
    
  }
  if (tempo - tempoinicial > tempocha) {  // Se passar o tempo ideal:
    u8g.firstPage();
    do {
      u8g.setFont(u8g_font_unifont);
      u8g.drawStr( 5, 15, "Cha pronto");
    } while ( u8g.nextPage() );           //Printa "Cha pronto"
    digitalWrite(rele, LOW);              // Desliga o rele
    while (1);                            // Faz o arduino parar de rodar os comandos ("Desligar ele")
  }
delay(2000);
}

void tea() {
  if (cha == 1) { //cha preto
    temperaturacha = 95;
    tempocha = 240000;
  }
  else if (cha == 2) { //cha branco
    temperaturacha = 67.5;
    tempocha = 360000;
  }
  else if (cha == 3) { //cha verde
    temperaturacha = 77.5;
    tempocha = 180000;
  }
  else if (cha == 4) { //cha amarelo
    temperaturacha = 72.5;
    tempocha = 90000;
  }
  else {
    setup();      // Caso a entrada no botão seja invalida, chamando setup();, o arduino voltará aos comandos de leitura do botão
  }
}
```